package pro.litvinovg.w2phtml.gui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import static pro.litvinovg.w2phtml.gui.Contstants.*;


public class EpubPanel extends BasePanel {
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public EpubPanel(HashMap<String, Component> configuration, Localizer localizer, UIPreferences preferences) {
		super(localizer, configuration, preferences);
		
		JLabel lb_FilterLetterSpacing = new JLabel(localizer.getTranslation(LABEL_MIN_LETTER_SPACING));
		JLabel lb_TargetFormat_description = new JLabel(localizer.getTranslation(LABEL_TARGET_FORMAT));
		JLabel lb_Scale = new JLabel(localizer.getTranslation(LABEL_SCALE));
		JLabel lb_FilePath = new JLabel(localizer.getTranslation(LABEL_INPUT_FILE_PATH));
		JLabel lb_TargetFormat = addTargetFormat(EPUB3_TARGET_FORMAT);
		JLabel lb_ImageResolution = new JLabel(localizer.getTranslation(LABEL_IMAGE_RESOLUTION));
		JLabel lb_OutFilePath = new JLabel(localizer.getTranslation(OUTPUT_FILE_PATH));
		JLabel lb_pageBreakInlineStyle = new JLabel(localizer.getTranslation(LABEL_BREAK_STYLE));

		JTextField tf_FilterLetterSpacing = addLetterSpacingFilter();
		JTextField tf_OutputFile = addOutputFileTextField();
		JTextField tf_inputFile = addInputFile();
		JTextField tf_Scale = addScaling();
		JTextField tf_pageBreakInlineStyle = addPageBreakStyle();
		
		JCheckBox cb_UseMathJax = addMathJaxCB();
		JCheckBox cb_IgnoreEmptyParagraphs = addIgnoreEmptyParsCB();
		JCheckBox cb_IgnoreHardLineBreaks = addIgnoreHardLineBreaks();
		JCheckBox cb_InlineStyles = addInlineStyles();
		JCheckBox cb_EmbedVectorImages = addEmbedVectorImages();
		JCheckBox cb_EmbedRaster = addEmbedRasterImages();
		JCheckBox cb_convertToPx = addConvertToPX();
		JCheckBox cb_Pagination = addPagination();

		JComboBox cbox_image_resolution = addImageResolution();
		
		JButton btn_ChooseOutputFile = addChooseOutputButton(tf_OutputFile, EPUB_FILE_EXTENSION);
		JButton btn_chooseFile = addButtonChooseFile(localizer, tf_OutputFile, tf_inputFile);

		GroupLayout gl_panel_configHTML = new GroupLayout(this);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(34)
					.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 184, GroupLayout.PREFERRED_SIZE)
					.addGap(7)
					.addComponent(tf_pageBreakInlineStyle, GroupLayout.DEFAULT_SIZE, 802, Short.MAX_VALUE)
					.addGap(60))
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(32)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_ImageResolution, GroupLayout.PREFERRED_SIZE, 336, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(cbox_image_resolution, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addContainerGap())
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
							.addComponent(cb_Pagination, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE)
											.addPreferredGap(ComponentPlacement.RELATED)
											.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(lb_FilterLetterSpacing, GroupLayout.DEFAULT_SIZE, 307, Short.MAX_VALUE)
											.addPreferredGap(ComponentPlacement.RELATED)
											.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 58, GroupLayout.PREFERRED_SIZE)
											.addGap(215))
										.addComponent(cb_convertToPx, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
										.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 389, GroupLayout.PREFERRED_SIZE)
										.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 405, GroupLayout.PREFERRED_SIZE)
										.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 409, GroupLayout.PREFERRED_SIZE)
										.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 313, GroupLayout.PREFERRED_SIZE)
										.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 349, GroupLayout.PREFERRED_SIZE)
										.addComponent(cb_EmbedRaster, GroupLayout.PREFERRED_SIZE, 416, GroupLayout.PREFERRED_SIZE))
									.addGap(463))
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addGap(1)
											.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 184, GroupLayout.PREFERRED_SIZE)
											.addGap(10)
											.addComponent(tf_OutputFile, GroupLayout.DEFAULT_SIZE, 668, Short.MAX_VALUE)
											.addGap(21)
											.addComponent(btn_ChooseOutputFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)
											.addGap(10))
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(lb_TargetFormat_description)
											.addPreferredGap(ComponentPlacement.UNRELATED)
											.addComponent(lb_TargetFormat, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE))
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addGap(3)
											.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 178, GroupLayout.PREFERRED_SIZE)
											.addGap(14)
											.addComponent(tf_inputFile, GroupLayout.DEFAULT_SIZE, 667, Short.MAX_VALUE)
											.addGap(22)
											.addComponent(btn_chooseFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)
											.addGap(10)))
									.addGap(48))))))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.TRAILING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
								.addComponent(lb_TargetFormat_description)
								.addComponent(lb_TargetFormat))
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addGap(16)
									.addComponent(tf_inputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addGap(12)
									.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 17, GroupLayout.PREFERRED_SIZE)))
							.addGap(2))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(btn_chooseFile)
							.addPreferredGap(ComponentPlacement.RELATED)))
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(7)
							.addComponent(btn_ChooseOutputFile))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(8)
							.addComponent(tf_OutputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(10)
							.addComponent(lb_OutFilePath)))
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(8)
							.addComponent(tf_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(7)
							.addComponent(lb_pageBreakInlineStyle)))
					.addGap(22)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_Scale))
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(8)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 18, GroupLayout.PREFERRED_SIZE)
						.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_InlineStyles)
					.addGap(7)
					.addComponent(cb_EmbedVectorImages)
					.addGap(7)
					.addComponent(cb_EmbedRaster)
					.addGap(7)
					.addComponent(cb_convertToPx)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addGap(7)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_UseMathJax)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_Pagination)
					.addGap(7)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_ImageResolution)
						.addComponent(cbox_image_resolution, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addContainerGap(118, Short.MAX_VALUE))
		);
		this.setLayout(gl_panel_configHTML);
	}

	private JButton addButtonChooseFile(Localizer localizer, JTextField tf_OutputFile, JTextField tf_inputFile) {
		JButton btn_chooseFile = new JButton(localizer.getTranslation(LABEL_BUTTON_CHOOSE));
		btn_chooseFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FileDialog fileDialog = new FileDialog();
				String newFilePath = fileDialog.chooseFile(tf_inputFile.getText(),ODT_FILE_EXTENSION);
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_inputFile.setText(newFilePath);
					setOutputFilePath(newFilePath,tf_OutputFile,EPUB_FILE_EXTENSION);
				}
			}
		});
		return btn_chooseFile;
	}
}
