package pro.litvinovg.w2phtml.gui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import static pro.litvinovg.w2phtml.gui.Contstants.*;

public class HTMLPanel extends BasePanel{
	private static final long serialVersionUID = 1L;
	
	public static void main(String[] args) {
		Localizer localizerStub =  new Localizer();
		HashMap<String, Component> configStub = new HashMap<String,Component>();
		UIPreferences prefStub = PreferencesStorage.getDefaultHTML(null);
		Object htmlPanel = new HTMLPanel(configStub,localizerStub,prefStub);
	}
	
	public HTMLPanel(HashMap<String, Component> configuration, Localizer localizer, UIPreferences preferences) {
		super(localizer, configuration, preferences);
		
		JLabel lb_SplitByLevel = new JLabel(localizer.getTranslation(LABEL_SPLIT_BY_HEADING));
		JLabel lb_FilterLetterSpacing = new JLabel(localizer.getTranslation(LABEL_MIN_LETTER_SPACING));
		JLabel lb_TargetFormat = addTargetFormat(HTML5_TARGET_FORMAT);
		JLabel lb_Scale = new JLabel(localizer.getTranslation(LABEL_SCALE));
		JLabel lb_MaxWidth = new JLabel(localizer.getTranslation(LABEL_MAX_BODY_WIDTH));
		JLabel lb_FilePath = new JLabel(localizer.getTranslation(LABEL_INPUT_FILE_PATH));
		JLabel lb_TargetFormat_description = new JLabel(localizer.getTranslation(LABEL_TARGET_FORMAT));
		JLabel lb_OutFilePath = new JLabel(localizer.getTranslation(OUTPUT_FILE_PATH));
		JLabel lb_ImageResolution = new JLabel(localizer.getTranslation(LABEL_IMAGE_RESOLUTION));
		JLabel lb_pageBreakInlineStyle = new JLabel(localizer.getTranslation(LABEL_BREAK_STYLE));

		JTextField tf_FilterLetterSpacing = addLetterSpacingFilter();
		JTextField tf_Scale = addScaling();
		JTextField tf_MaxWidth = addMaxWidth();
		JTextField tf_inputFile = addInputFile();
		JTextField tf_OutputFile = addOutputFileTextField();
		JTextField tf_pageBreakInlineStyle = addPageBreakStyle();
		
		JCheckBox cb_UseMathJax = addMathJaxCB();
		JCheckBox cb_IgnoreEmptyParagraphs = addIgnoreEmptyParsCB();
		JCheckBox cb_IgnoreHardLineBreaks = addIgnoreHardLineBreaks();
		JCheckBox cb_SplitWholePagesOnly = addSplitWholePagesOnly();
		JCheckBox cb_Greenstone = addGreenstoneTags();
		JCheckBox cb_InlineStyles = addInlineStyles();
		JCheckBox cb_EmbedRaster = addEmbedRasterImages();
		JCheckBox cb_EmbedVectorImages = addEmbedVectorImages();
		JCheckBox cb_convertToPx = addConvertToPX();
		JCheckBox cb_Pagination = addPagination();
		
		JComboBox cbox_image_resolution = addImageResolution();
		JComboBox cbox_SplitByLevel = addSplitByLevel();

		JButton btn_chooseFile = addButtonChooseFile(localizer, tf_inputFile, tf_OutputFile);
		JButton btn_ChooseOutputFile = addChooseOutputButton(tf_OutputFile, HTML_FILE_EXTENSION);
		
		GroupLayout gl_panel_configHTML = new GroupLayout(this);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(32)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addComponent(lb_SplitByLevel, GroupLayout.PREFERRED_SIZE, 454, GroupLayout.PREFERRED_SIZE)
								.addPreferredGap(ComponentPlacement.RELATED)
								.addComponent(cbox_SplitByLevel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)
								.addGap(541))
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addComponent(cb_Greenstone, GroupLayout.PREFERRED_SIZE, 482, GroupLayout.PREFERRED_SIZE)
									.addContainerGap())
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 441, GroupLayout.PREFERRED_SIZE)
									.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 341, GroupLayout.PREFERRED_SIZE)
											.addContainerGap())
										.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
											.addGroup(gl_panel_configHTML.createSequentialGroup()
												.addComponent(cb_convertToPx, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
												.addContainerGap())
											.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
												.addGroup(gl_panel_configHTML.createSequentialGroup()
													.addComponent(cb_EmbedRaster)
													.addContainerGap())
												.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
													.addGroup(gl_panel_configHTML.createSequentialGroup()
														.addComponent(cb_EmbedVectorImages, GroupLayout.PREFERRED_SIZE, 276, GroupLayout.PREFERRED_SIZE)
														.addContainerGap())
													.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
														.addGroup(gl_panel_configHTML.createSequentialGroup()
															.addComponent(cb_InlineStyles, GroupLayout.PREFERRED_SIZE, 322, GroupLayout.PREFERRED_SIZE)
															.addContainerGap())
														.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
															.addGroup(gl_panel_configHTML.createSequentialGroup()
																.addComponent(lb_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 350, GroupLayout.PREFERRED_SIZE)
																.addPreferredGap(ComponentPlacement.RELATED)
																.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, 58, GroupLayout.PREFERRED_SIZE)
																.addGap(635))
															.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																.addGroup(gl_panel_configHTML.createSequentialGroup()
																	.addComponent(lb_MaxWidth, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE)
																	.addContainerGap())
																.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																	.addGroup(gl_panel_configHTML.createSequentialGroup()
																		.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 168, GroupLayout.PREFERRED_SIZE)
																		.addContainerGap())
																	.addGroup(gl_panel_configHTML.createSequentialGroup()
																		.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																			.addGroup(gl_panel_configHTML.createSequentialGroup()
																				.addComponent(lb_TargetFormat_description, GroupLayout.PREFERRED_SIZE, 178, GroupLayout.PREFERRED_SIZE)
																				.addPreferredGap(ComponentPlacement.RELATED)
																				.addComponent(lb_TargetFormat, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE))
																			.addGroup(gl_panel_configHTML.createSequentialGroup()
																				.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																					.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 193, GroupLayout.PREFERRED_SIZE)
																					.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 191, GroupLayout.PREFERRED_SIZE))
																				.addPreferredGap(ComponentPlacement.RELATED)
																				.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																					.addComponent(tf_OutputFile, Alignment.TRAILING, GroupLayout.DEFAULT_SIZE, 558, Short.MAX_VALUE)
																					.addComponent(tf_inputFile, Alignment.TRAILING, GroupLayout.DEFAULT_SIZE, 558, Short.MAX_VALUE))
																				.addPreferredGap(ComponentPlacement.RELATED)
																				.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																					.addComponent(btn_ChooseOutputFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)
																					.addComponent(btn_chooseFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)))
																			.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 352, GroupLayout.PREFERRED_SIZE)
																			.addComponent(cb_SplitWholePagesOnly, GroupLayout.PREFERRED_SIZE, 323, GroupLayout.PREFERRED_SIZE)
																			.addGroup(gl_panel_configHTML.createSequentialGroup()
																				.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 191, GroupLayout.PREFERRED_SIZE)
																				.addPreferredGap(ComponentPlacement.RELATED)
																				.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																					.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE)
																					.addComponent(tf_pageBreakInlineStyle, GroupLayout.DEFAULT_SIZE, 707, Short.MAX_VALUE)
																					.addComponent(tf_MaxWidth, GroupLayout.PREFERRED_SIZE, 175, GroupLayout.PREFERRED_SIZE))))
																		.addGap(145)))))))))))))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addComponent(cb_Pagination, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addComponent(lb_ImageResolution, GroupLayout.PREFERRED_SIZE, 366, GroupLayout.PREFERRED_SIZE)
									.addGap(4)
									.addComponent(cbox_image_resolution, GroupLayout.PREFERRED_SIZE, 70, GroupLayout.PREFERRED_SIZE)))
							.addGap(615))))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(12)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_TargetFormat_description)
						.addComponent(lb_TargetFormat))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
							.addComponent(tf_inputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addComponent(btn_chooseFile))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(2)
							.addComponent(lb_FilePath)))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_OutFilePath)
						.addComponent(tf_OutputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(btn_ChooseOutputFile))
					.addGap(12)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_pageBreakInlineStyle)
						.addComponent(tf_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(18)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_Scale)
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_MaxWidth)
						.addComponent(tf_MaxWidth, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_FilterLetterSpacing)
						.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_InlineStyles)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_EmbedVectorImages)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_EmbedRaster)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_convertToPx)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_Greenstone)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_SplitByLevel, GroupLayout.PREFERRED_SIZE, 16, GroupLayout.PREFERRED_SIZE)
						.addComponent(cbox_SplitByLevel, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_SplitWholePagesOnly)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_UseMathJax)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_Pagination)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_ImageResolution)
						.addComponent(cbox_image_resolution, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(101))
		);
		this.setLayout(gl_panel_configHTML);
	}

	private JButton addButtonChooseFile(Localizer localizer, JTextField tf_inputFile, JTextField tf_OutputFile) {
		JButton btn_chooseFile = new JButton(localizer.getTranslation(LABEL_BUTTON_CHOOSE));
		btn_chooseFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String newFilePath = FileDialog.chooseFile(tf_inputFile.getText(),ODT_FILE_EXTENSION);
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_inputFile.setText(newFilePath);
					setOutputFilePath(newFilePath,tf_OutputFile,HTML_FILE_EXTENSION);
				}
			}
		});
		return btn_chooseFile;
	}
}

