package pro.litvinovg.w2phtml.gui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import static pro.litvinovg.w2phtml.gui.Contstants.*;


public class RDFPanel extends BasePanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public RDFPanel(HashMap<String, Component> configuration, Localizer localizer, UIPreferences preferences) {
		super(localizer, configuration, preferences);
		
		JLabel lb_FilterLetterSpacing = new JLabel(localizer.getTranslation(LABEL_MIN_LETTER_SPACING));
		JLabel lb_TargetFormat = addTargetFormat(RDF_TARGET_FORMAT);
		JLabel lb_Scale = new JLabel(localizer.getTranslation(LABEL_SCALE));
		JLabel lb_FilePath = new JLabel(localizer.getTranslation(LABEL_INPUT_FILE_PATH));
		JLabel lb_TargetFormat_description = new JLabel(localizer.getTranslation(LABEL_TARGET_FORMAT));
		JLabel lb_OutFilePath = new JLabel(localizer.getTranslation(OUTPUT_FILE_PATH));
		JLabel lb_ImageResolution = new JLabel(localizer.getTranslation(LABEL_IMAGE_RESOLUTION));
		JLabel lb_type = new JLabel(localizer.getTranslation(LABEL_TYPE));
		JLabel lb_metadataFilePath = new JLabel(localizer.getTranslation(LABEL_METADATA_PATH));
		JLabel lb_pageBreakInlineStyle = new JLabel(localizer.getTranslation(LABEL_BREAK_STYLE));
		
		JTextField tf_OutputFile = addOutputFileTextField();
		JTextField tf_FilterLetterSpacing = addLetterSpacingFilter();	
		JTextField tf_Scale = addScaling();
		JTextField tf_inputFile = addInputFile();
		JTextField tf_metadataPath = addMetadataPath(configuration);
		JTextField tf_pageBreakInlineStyle = addPageBreakStyle();
		
		JCheckBox cb_UseMathJax = addMathJaxCB();
		JCheckBox cb_IgnoreEmptyParagraphs = addIgnoreEmptyParsCB();
		JCheckBox cb_IgnoreHardLineBreaks = addIgnoreHardLineBreaks();
		JCheckBox cb_InlineStyles = addInlineStyles();
		cb_InlineStyles.setEnabled(false);
		JCheckBox cb_EmbedVectorImages = addEmbedVectorImages();
		cb_EmbedVectorImages.setEnabled(false);
		JCheckBox cb_EmbedRaster = addEmbedRasterImages();
		cb_EmbedRaster.setEnabled(false);
		JCheckBox cb_convertToPx = addConvertToPX();
		JCheckBox cb_Pagination = addPagination();

		JComboBox cbox_image_resolution = addImageResolution();
		JComboBox cbox_type = addPubTypes(configuration, preferences);

		JButton btn_ChooseOutputFile = addChooseOutputButton(tf_OutputFile, RDF_FILE_EXTENSION);
		JButton btn_ChooseFile = addChooseFile(localizer, tf_OutputFile, tf_inputFile, tf_metadataPath);
		JButton btn_metadataChoose = addMetadataButton(localizer, tf_metadataPath);
		
		GroupLayout gl_panel_configHTML = new GroupLayout(this);
		gl_panel_configHTML.setHorizontalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGap(32)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addComponent(lb_ImageResolution, GroupLayout.PREFERRED_SIZE, 369, GroupLayout.PREFERRED_SIZE)
							.addGap(4)
							.addComponent(cbox_image_resolution, GroupLayout.PREFERRED_SIZE, 70, GroupLayout.PREFERRED_SIZE)
							.addContainerGap())
						.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addComponent(cb_Pagination, GroupLayout.PREFERRED_SIZE, 303, GroupLayout.PREFERRED_SIZE)
								.addContainerGap())
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addComponent(cb_convertToPx, GroupLayout.PREFERRED_SIZE, 592, GroupLayout.PREFERRED_SIZE)
									.addContainerGap())
								.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
									.addGroup(gl_panel_configHTML.createSequentialGroup()
										.addComponent(cb_EmbedRaster)
										.addContainerGap())
									.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
										.addGroup(gl_panel_configHTML.createSequentialGroup()
											.addComponent(cb_EmbedVectorImages)
											.addContainerGap())
										.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
											.addGroup(gl_panel_configHTML.createSequentialGroup()
												.addComponent(lb_FilterLetterSpacing)
												.addPreferredGap(ComponentPlacement.RELATED)
												.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
												.addGap(599))
											.addGroup(gl_panel_configHTML.createSequentialGroup()
												.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
													.addComponent(cb_InlineStyles)
													.addGroup(gl_panel_configHTML.createSequentialGroup()
														.addPreferredGap(ComponentPlacement.RELATED)
														.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
															.addComponent(lb_TargetFormat_description, GroupLayout.PREFERRED_SIZE, 311, GroupLayout.PREFERRED_SIZE)
															.addGroup(gl_panel_configHTML.createSequentialGroup()
																.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																	.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 176, GroupLayout.PREFERRED_SIZE)
																	.addComponent(lb_metadataFilePath, GroupLayout.PREFERRED_SIZE, 177, GroupLayout.PREFERRED_SIZE)
																	.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 187, GroupLayout.PREFERRED_SIZE))
																.addPreferredGap(ComponentPlacement.RELATED)
																.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
																	.addComponent(lb_TargetFormat, GroupLayout.PREFERRED_SIZE, 68, GroupLayout.PREFERRED_SIZE)
																	.addComponent(tf_OutputFile, GroupLayout.DEFAULT_SIZE, 561, Short.MAX_VALUE)
																	.addGroup(gl_panel_configHTML.createSequentialGroup()
																		.addComponent(tf_metadataPath, GroupLayout.DEFAULT_SIZE, 560, Short.MAX_VALUE)
																		.addGap(1))
																	.addGroup(gl_panel_configHTML.createSequentialGroup()
																		.addComponent(tf_inputFile, GroupLayout.DEFAULT_SIZE, 558, Short.MAX_VALUE)
																		.addGap(3)))))
														.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
															.addGroup(gl_panel_configHTML.createSequentialGroup()
																.addGap(11)
																.addComponent(btn_ChooseFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE))
															.addGroup(gl_panel_configHTML.createSequentialGroup()
																.addGap(12)
																.addComponent(btn_metadataChoose, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE))
															.addGroup(gl_panel_configHTML.createSequentialGroup()
																.addGap(11)
																.addComponent(btn_ChooseOutputFile, GroupLayout.PREFERRED_SIZE, 113, GroupLayout.PREFERRED_SIZE)))
														.addGap(149))
													.addGroup(gl_panel_configHTML.createSequentialGroup()
														.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 196, GroupLayout.PREFERRED_SIZE)
														.addPreferredGap(ComponentPlacement.RELATED)
														.addComponent(tf_pageBreakInlineStyle, GroupLayout.DEFAULT_SIZE, 681, Short.MAX_VALUE)
														.addGap(145))
													.addGroup(gl_panel_configHTML.createSequentialGroup()
														.addComponent(lb_type, GroupLayout.PREFERRED_SIZE, 148, GroupLayout.PREFERRED_SIZE)
														.addPreferredGap(ComponentPlacement.RELATED)
														.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
															.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, 98, GroupLayout.PREFERRED_SIZE)
															.addComponent(cbox_type, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))))
												.addGap(21))
											.addGroup(gl_panel_configHTML.createSequentialGroup()
												.addComponent(lb_Scale, GroupLayout.PREFERRED_SIZE, 137, GroupLayout.PREFERRED_SIZE)
												.addContainerGap())))))
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addComponent(cb_IgnoreEmptyParagraphs, GroupLayout.PREFERRED_SIZE, 339, GroupLayout.PREFERRED_SIZE)
								.addContainerGap())
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addComponent(cb_UseMathJax, GroupLayout.PREFERRED_SIZE, 345, GroupLayout.PREFERRED_SIZE)
								.addContainerGap())
							.addGroup(gl_panel_configHTML.createSequentialGroup()
								.addComponent(cb_IgnoreHardLineBreaks, GroupLayout.PREFERRED_SIZE, 344, GroupLayout.PREFERRED_SIZE)
								.addContainerGap()))))
		);
		gl_panel_configHTML.setVerticalGroup(
			gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_configHTML.createSequentialGroup()
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addContainerGap()
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
								.addComponent(lb_TargetFormat_description)
								.addComponent(lb_TargetFormat))
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addGap(22)
									.addComponent(tf_inputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
								.addGroup(gl_panel_configHTML.createSequentialGroup()
									.addGap(24)
									.addComponent(lb_FilePath, GroupLayout.PREFERRED_SIZE, 19, GroupLayout.PREFERRED_SIZE)))
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.LEADING)
								.addComponent(tf_metadataPath, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(lb_metadataFilePath, GroupLayout.PREFERRED_SIZE, 17, GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
								.addComponent(lb_OutFilePath, GroupLayout.PREFERRED_SIZE, 18, GroupLayout.PREFERRED_SIZE)
								.addComponent(tf_OutputFile, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
						.addGroup(gl_panel_configHTML.createSequentialGroup()
							.addGap(46)
							.addComponent(btn_ChooseFile)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(btn_metadataChoose)
							.addGap(7)
							.addComponent(btn_ChooseOutputFile)))
					.addGap(20)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, 23, GroupLayout.PREFERRED_SIZE)
						.addComponent(tf_pageBreakInlineStyle, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(18)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_type)
						.addComponent(cbox_type, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_Scale)
						.addComponent(tf_Scale, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_FilterLetterSpacing)
						.addComponent(tf_FilterLetterSpacing, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(10)
					.addComponent(cb_InlineStyles)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_EmbedVectorImages)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_EmbedRaster)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_convertToPx)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_IgnoreHardLineBreaks)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_IgnoreEmptyParagraphs)
					.addPreferredGap(ComponentPlacement.UNRELATED)
					.addComponent(cb_UseMathJax)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(cb_Pagination)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel_configHTML.createParallelGroup(Alignment.BASELINE)
						.addComponent(lb_ImageResolution)
						.addComponent(cbox_image_resolution, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addContainerGap(87, Short.MAX_VALUE))
		);
		this.setLayout(gl_panel_configHTML);
	}

	private JButton addMetadataButton(Localizer localizer, JTextField tf_metadataPath) {
		JButton btn_metadataChoose = new JButton(localizer.getTranslation(LABEL_BUTTON_CHOOSE));
		btn_metadataChoose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String newFilePath = FileDialog.chooseFile(tf_metadataPath.getText(),CSV_FILE_EXTENSION);
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_metadataPath.setText(newFilePath);
				}
			}
		});
		return btn_metadataChoose;
	}

	private JTextField addMetadataPath(HashMap<String, Component> configuration) {
		JTextField tf_metadataPath = new JTextField("");
		tf_metadataPath.setColumns(10);
		configuration.put(ARG_CSV_METADATA, tf_metadataPath);
		return tf_metadataPath;
	}

	private JButton addChooseFile(Localizer localizer, JTextField tf_OutputFile, JTextField tf_inputFile,
			JTextField tf_metadataPath) {
		JButton btnChooseFile = new JButton(localizer.getTranslation(LABEL_BUTTON_CHOOSE));
		btnChooseFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String newFilePath = FileDialog.chooseFile(tf_inputFile.getText(),ODT_FILE_EXTENSION);
				if (newFilePath != null && !newFilePath.isEmpty()) {
					tf_inputFile.setText(newFilePath);
					setOutputFilePath(newFilePath,tf_OutputFile,RDF_FILE_EXTENSION);
					setMetadataFilePath(newFilePath,tf_metadataPath,CSV_FILE_EXTENSION);
				}
			}
		});
		return btnChooseFile;
	}

	private JComboBox addPubTypes(HashMap<String, Component> configuration, UIPreferences preferences) {
		JComboBox cbox_type = new JComboBox(preferences.getAll(PREF_PUBLICATION_TYPES));
		cbox_type.setSelectedIndex(Integer.parseInt(preferences.get(PREF_DEFAULT_PUBLICATION_TYPE)));
		configuration.put(ARG_RDF_TYPE, cbox_type);
		return cbox_type;
	}


}
